Index: src/CodeGen/CodeGenerator.cc
===================================================================
--- src/CodeGen/CodeGenerator.cc	(revision 32a1e5fd4bfb9f3c11a49cb264a4781656cd15ba)
+++ src/CodeGen/CodeGenerator.cc	(revision 830c21a9176191cb1eddb5c1201cdd5cb9c6a659)
@@ -258,5 +258,7 @@
 	      
 				  case OT_CALL:
-					// there are no intrinsic definitions of the function call operator
+				  case OT_CTOR:
+				  case OT_DTOR:
+					// there are no intrinsic definitions of the function call operator or constructors or destructors
 					assert( false );
 					break;
Index: src/CodeGen/OperatorTable.cc
===================================================================
--- src/CodeGen/OperatorTable.cc	(revision 32a1e5fd4bfb9f3c11a49cb264a4781656cd15ba)
+++ src/CodeGen/OperatorTable.cc	(revision 830c21a9176191cb1eddb5c1201cdd5cb9c6a659)
@@ -9,7 +9,7 @@
 // Author           : Richard C. Bilson
 // Created On       : Mon May 18 07:44:20 2015
-// Last Modified By : Peter A. Buhr
-// Last Modified On : Tue Jun 23 17:41:14 2015
-// Update Count     : 5
+// Last Modified By : Rob Schluntz
+// Last Modified On : Wed Jun 24 16:17:34 2015
+// Update Count     : 7
 //
 
@@ -21,4 +21,6 @@
 		const OperatorInfo tableValues[] = {
 			{	"?[?]",		"",		"_operator_index",				OT_INDEX			},
+			{	"?{}",		"",		"_constructor",					OT_CTOR				},
+			{	"-?{}",		"",		"_destructor",					OT_DTOR				}, // -?{}, !?{}, $?{}, ??{}, ?destroy, ?delete
 			{	"?()",		"",		"_operator_call",				OT_CALL				},
 			{	"?++",		"++",	"_operator_postincr",			OT_POSTFIXASSIGN	},
Index: src/CodeGen/OperatorTable.h
===================================================================
--- src/CodeGen/OperatorTable.h	(revision 32a1e5fd4bfb9f3c11a49cb264a4781656cd15ba)
+++ src/CodeGen/OperatorTable.h	(revision 830c21a9176191cb1eddb5c1201cdd5cb9c6a659)
@@ -9,7 +9,7 @@
 // Author           : Richard C. Bilson
 // Created On       : Mon May 18 07:44:20 2015
-// Last Modified By : Peter A. Buhr
-// Last Modified On : Tue Jun 23 16:09:27 2015
-// Update Count     : 3
+// Last Modified By : Rob Schluntz
+// Last Modified On : Wed Jun 24 16:17:57 2015
+// Update Count     : 5
 //
 
@@ -22,4 +22,6 @@
 	enum OperatorType {
 		OT_INDEX,
+		OT_CTOR,
+		OT_DTOR,
 		OT_CALL,
 		OT_PREFIX,
Index: src/MakeLibCfa.cc
===================================================================
--- src/MakeLibCfa.cc	(revision 32a1e5fd4bfb9f3c11a49cb264a4781656cd15ba)
+++ src/MakeLibCfa.cc	(revision 830c21a9176191cb1eddb5c1201cdd5cb9c6a659)
@@ -9,7 +9,7 @@
 // Author           : Richard C. Bilson
 // Created On       : Sat May 16 10:33:33 2015
-// Last Modified By : Peter A. Buhr
-// Last Modified On : Fri Jun 26 16:52:59 2015
-// Update Count     : 14
+// Last Modified By : Rob Schluntz
+// Last Modified On : Fri Jul 03 18:11:37 2015
+// Update Count     : 18
 // 
 
@@ -77,4 +77,6 @@
 				break;
 			}
+		  case CodeGen::OT_CTOR:
+		  case CodeGen::OT_DTOR:
 		  case CodeGen::OT_CONSTANT:
 		  case CodeGen::OT_LABELADDRESS:
Index: src/Parser/LinkageSpec.cc
===================================================================
--- src/Parser/LinkageSpec.cc	(revision 32a1e5fd4bfb9f3c11a49cb264a4781656cd15ba)
+++ src/Parser/LinkageSpec.cc	(revision 830c21a9176191cb1eddb5c1201cdd5cb9c6a659)
@@ -9,7 +9,7 @@
 // Author           : Rodolfo G. Esteves
 // Created On       : Sat May 16 13:22:09 2015
-// Last Modified By : Peter A. Buhr
-// Last Modified On : Sat May 16 13:23:21 2015
-// Update Count     : 2
+// Last Modified By : Rob Schluntz
+// Last Modified On : Wed Aug 19 15:53:05 2015
+// Update Count     : 5
 // 
 
@@ -79,4 +79,19 @@
 }
 
+
+bool LinkageSpec::isOverridable( Type t ) {
+	switch ( t ) {
+	  case Intrinsic:
+	  case AutoGen:
+		return true;
+	  case Cforall:
+	  case C:
+	  case Compiler:
+		return false;
+	}
+	assert( false );
+	return false;
+}
+
 bool LinkageSpec::isBuiltin( Type t ) {
 	switch ( t ) {
Index: src/Parser/LinkageSpec.h
===================================================================
--- src/Parser/LinkageSpec.h	(revision 32a1e5fd4bfb9f3c11a49cb264a4781656cd15ba)
+++ src/Parser/LinkageSpec.h	(revision 830c21a9176191cb1eddb5c1201cdd5cb9c6a659)
@@ -9,7 +9,7 @@
 // Author           : Rodolfo G. Esteves
 // Created On       : Sat May 16 13:24:28 2015
-// Last Modified By : Peter A. Buhr
-// Last Modified On : Sat May 16 13:26:14 2015
-// Update Count     : 3
+// Last Modified By : Rob Schluntz
+// Last Modified On : Tue Aug 18 14:11:55 2015
+// Update Count     : 5
 //
 
@@ -34,4 +34,5 @@
 	static bool isGeneratable( Type );
 	static bool isOverloadable( Type );
+	static bool isOverridable( Type );
 	static bool isBuiltin( Type );
 };
Index: src/Parser/ParseNode.h
===================================================================
--- src/Parser/ParseNode.h	(revision 32a1e5fd4bfb9f3c11a49cb264a4781656cd15ba)
+++ src/Parser/ParseNode.h	(revision 830c21a9176191cb1eddb5c1201cdd5cb9c6a659)
@@ -10,6 +10,6 @@
 // Created On       : Sat May 16 13:28:16 2015
 // Last Modified By : Rob Schluntz
-// Last Modified On : Wed Aug 12 13:27:11 2015
-// Update Count     : 172
+// Last Modified On : Wed Aug 19 15:59:27 2015
+// Update Count     : 174
 //
 
@@ -180,5 +180,6 @@
 				Assign, MulAssn, DivAssn, ModAssn, PlusAssn, MinusAssn, LSAssn, RSAssn, AndAssn, 
 				ERAssn, OrAssn, Index, FieldSel, PFieldSel, Range,
-				UnPlus, UnMinus, AddressOf, PointTo, Neg, BitNeg, Incr, IncrPost, Decr, DecrPost, LabelAddress
+				UnPlus, UnMinus, AddressOf, PointTo, Neg, BitNeg, Incr, IncrPost, Decr, DecrPost, LabelAddress,
+				Ctor, Dtor,
 	};
 
Index: src/SymTab/IdTable.cc
===================================================================
--- src/SymTab/IdTable.cc	(revision 32a1e5fd4bfb9f3c11a49cb264a4781656cd15ba)
+++ src/SymTab/IdTable.cc	(revision 830c21a9176191cb1eddb5c1201cdd5cb9c6a659)
@@ -9,7 +9,7 @@
 // Author           : Richard C. Bilson
 // Created On       : Sun May 17 17:04:02 2015
-// Last Modified By : Peter A. Buhr
-// Last Modified On : Sun May 17 17:07:43 2015
-// Update Count     : 3
+// Last Modified By : Rob Schluntz
+// Last Modified On : Wed Aug 19 15:47:58 2015
+// Update Count     : 38
 //
 
@@ -52,4 +52,9 @@
 		if ( decl->get_linkage() == LinkageSpec::C ) {
 			manglename = name;
+		} else if ( LinkageSpec::isOverridable( decl->get_linkage() ) ) {
+			// mangle the name without including the appropriate suffix
+			// this will make it so that overridable routines are placed
+			// into the same "bucket" as their user defined versions.
+			manglename = Mangler::mangle( decl, false );
 		} else {
 			manglename = Mangler::mangle( decl );
@@ -64,18 +69,27 @@
 			std::stack< DeclEntry >& entry = it->second;
 			if ( ! entry.empty() && entry.top().second == scopeLevel ) {
+				// typesCompatible doesn't really do the right thing here. When checking compatibility of function types,
+				// we should ignore outermost pointer qualifiers, except _Atomic?
+
 				if ( decl->get_linkage() != LinkageSpec::C || ResolvExpr::typesCompatible( decl->get_type(), entry.top().first->get_type(), Indexer() ) ) {
 					FunctionDecl *newentry = dynamic_cast< FunctionDecl* >( decl );
 					FunctionDecl *old = dynamic_cast< FunctionDecl* >( entry.top().first );
-					if ( newentry && old && newentry->get_statements() && old->get_statements() ) {
-						throw SemanticError( "duplicate function definition for ", decl );
+					if ( LinkageSpec::isOverridable( old->get_linkage() ) ) {
+						// new definition shadows the autogenerated one, even at the same scope
+						declTable[ manglename ].push( DeclEntry( decl, scopeLevel ) );
+					} else if ( newentry && old && newentry->get_statements() && old->get_statements() ) {
+						throw SemanticError( "duplicate function definition for 1 ", decl );
 					} else {
+						// two objects with the same mangled name defined in the same scope.
+						// both objects must be marked extern for this to be okay
 						ObjectDecl *newobj = dynamic_cast< ObjectDecl* >( decl );
 						ObjectDecl *oldobj = dynamic_cast< ObjectDecl* >( entry.top().first );
-						if ( newobj && oldobj && newobj->get_init() && oldobj->get_init() ) {
+						if ( newobj && oldobj && newobj->get_storageClass() != DeclarationNode::Extern && oldobj->get_storageClass() != DeclarationNode::Extern ) {
 							throw SemanticError( "duplicate definition for ", decl );
 						} // if
 					} // if
 				} else {
-					throw SemanticError( "duplicate definition for ", decl );
+					// C definitions with the same name but incompatible types
+					throw SemanticError( "duplicate definition for 2 ", decl );
 				} // if
 			} else {
@@ -84,4 +98,5 @@
 		} // if
 		// ensure the set of routines with C linkage cannot be overloaded
+		// this ensures that no two declarations with the same unmangled name both have C linkage
 		for ( InnerTableType::iterator i = declTable.begin(); i != declTable.end(); ++i ) {
 			if ( ! i->second.empty() && i->second.top().first->get_linkage() == LinkageSpec::C && declTable.size() > 1 ) {
Index: src/SymTab/Mangler.cc
===================================================================
--- src/SymTab/Mangler.cc	(revision 32a1e5fd4bfb9f3c11a49cb264a4781656cd15ba)
+++ src/SymTab/Mangler.cc	(revision 830c21a9176191cb1eddb5c1201cdd5cb9c6a659)
@@ -9,7 +9,7 @@
 // Author           : Richard C. Bilson
 // Created On       : Sun May 17 21:40:29 2015
-// Last Modified By : Peter A. Buhr
-// Last Modified On : Mon Jun  8 15:12:12 2015
-// Update Count     : 8
+// Last Modified By : Rob Schluntz
+// Last Modified On : Wed Aug 19 15:52:24 2015
+// Update Count     : 19
 //
 
@@ -30,5 +30,5 @@
 
 namespace SymTab {
-	Mangler::Mangler() : nextVarNum( 0 ), isTopLevel( true ) {
+	Mangler::Mangler( bool mangleOverridable ) : nextVarNum( 0 ), isTopLevel( true ), mangleOverridable( mangleOverridable ) {
 	}
 
@@ -41,4 +41,5 @@
 		nextVarNum = rhs.nextVarNum;
 		isTopLevel = rhs.isTopLevel;
+		mangleOverridable = rhs.mangleOverridable;
 	}
 
@@ -59,4 +60,16 @@
 		mangleName << "__";
 		maybeAccept( declaration->get_type(), *this );
+		if ( mangleOverridable && LinkageSpec::isOverridable( declaration->get_linkage() ) ) {
+			// want to be able to override autogenerated and intrinsic routines,
+			// so they need a different name mangling
+			if ( declaration->get_linkage() == LinkageSpec::AutoGen ) {
+				mangleName << "autogen__";
+			} else if ( declaration->get_linkage() == LinkageSpec::Intrinsic ) {
+				mangleName << "intrinsic__";
+			} else {
+				// if we add another kind of overridable function, this has to change
+				assert( false );
+			} // if
+		}
 		isTopLevel = wasTopLevel;
 	}
@@ -214,5 +227,5 @@
 				varNums[ (*i )->get_name() ] = std::pair< int, int >( nextVarNum++, (int )(*i )->get_kind() );
 				for ( std::list< DeclarationWithType* >::iterator assert = (*i )->get_assertions().begin(); assert != (*i )->get_assertions().end(); ++assert ) {
-					Mangler sub_mangler;
+					Mangler sub_mangler( mangleOverridable );
 					sub_mangler.nextVarNum = nextVarNum;
 					sub_mangler.isTopLevel = false;
Index: src/SymTab/Mangler.h
===================================================================
--- src/SymTab/Mangler.h	(revision 32a1e5fd4bfb9f3c11a49cb264a4781656cd15ba)
+++ src/SymTab/Mangler.h	(revision 830c21a9176191cb1eddb5c1201cdd5cb9c6a659)
@@ -9,7 +9,7 @@
 // Author           : Richard C. Bilson
 // Created On       : Sun May 17 21:44:03 2015
-// Last Modified By : Peter A. Buhr
-// Last Modified On : Mon Jun  8 14:47:14 2015
-// Update Count     : 5
+// Last Modified By : Rob Schluntz
+// Last Modified On : Wed Aug 19 15:48:46 2015
+// Update Count     : 14
 //
 
@@ -25,5 +25,5 @@
 	  public:
 		template< typename SynTreeClass >
-	    static std::string mangle( SynTreeClass *decl ); // interface to clients
+	    static std::string mangle( SynTreeClass *decl, bool mangleOverridable = true ); // interface to clients
 
 ///   using Visitor::visit;
@@ -50,6 +50,7 @@
 		int nextVarNum;
 		bool isTopLevel;
+		bool mangleOverridable;
   
-		Mangler();
+		Mangler( bool mangleOverridable );
 		Mangler( const Mangler & );
   
@@ -61,6 +62,6 @@
 
 	template< typename SynTreeClass >
-	std::string Mangler::mangle( SynTreeClass *decl ) {
-		Mangler mangler;
+	std::string Mangler::mangle( SynTreeClass *decl, bool mangleOverridable ) {
+		Mangler mangler( mangleOverridable );
 		maybeAccept( decl, mangler );
 		return mangler.get_mangleName();